#
# spec file for package kdeconnect-kde
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           kdeconnect-kde
Version:        1.3.3
Release:        lp151.2.6.1
Summary:        Integrate Android with Linux desktops
License:        GPL-2.0+
Group:          Productivity/Networking/Other
Url:            https://community.kde.org/KDEConnect
Source:         https://download.kde.org/stable/kdeconnect/%{version}/src/%{name}-%{version}.tar.xz
Source1:        https://download.kde.org/stable/kdeconnect/%{version}/src/%{name}-%{version}.tar.xz.sig
Source100:      kdeconnect-kde.SuSEfirewall
Source101:      kdeconnect-kde-firewalld.xml
# PATCH-FIX-UPSTREAM
Patch0:         0001-Do-not-leak-the-local-user-in-the-device-name.patch
Patch1:         0002-Fix-use-after-free-in-LanLinkProvider-connectError.patch
Patch2:         0003-Limit-identity-packets-to-8KiB.patch
Patch3:         0004-Do-not-let-lanlink-connections-stay-open-for-long-wi.patch
Patch4:         0005-Don-t-brute-force-reading-the-socket.patch
Patch5:         0006-Limit-number-of-connected-sockets-from-unpaired-devi.patch
Patch6:         0007-Do-not-remember-more-than-a-few-identity-packets-at-.patch
Patch7:         0008-Limit-the-ports-we-try-to-connect-to-to-the-port-ran.patch
Patch8:         0009-Do-not-replace-connections-for-a-given-deviceId-if-t.patch
Patch9:         0001-Show-the-KCM-with-the-run-commands-open-when-a-setup.patch
Patch10:        0002-Add-a-verification-key-that-s-displayed-when-pairing.patch
BuildRequires:  cmake >= 3.0
BuildRequires:  extra-cmake-modules >= 5.42.0
BuildRequires:  kf5-filesystem
BuildRequires:  update-desktop-files
BuildRequires:  cmake(KF5ConfigWidgets)
BuildRequires:  cmake(KF5DBusAddons)
BuildRequires:  cmake(KF5Declarative)
BuildRequires:  cmake(KF5DocTools)
BuildRequires:  cmake(KF5I18n)
BuildRequires:  cmake(KF5IconThemes)
BuildRequires:  cmake(KF5KCMUtils)
BuildRequires:  cmake(KF5KIO) >= 5.42.0
BuildRequires:  cmake(KF5Notifications)
BuildRequires:  cmake(KF5Wayland)
BuildRequires:  cmake(Qca-qt5)
BuildRequires:  cmake(Qt5Quick) >= 5.7.0
BuildRequires:  cmake(Qt5X11Extras) >= 5.7.0
BuildRequires:  pkgconfig(dbus-1)
BuildRequires:  pkgconfig(libfakekey)
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(xtst)
Provides:       %{name}-devel = %{version}
Obsoletes:      %{name}-devel < %{version}
Conflicts:      kdeconnect-kde4
Recommends:     %{name}-lang = %{version}
Requires:       sshfs
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Integrate Android with Linux desktops.

Current feature list:
- Clipboard share: copy from or to your desktop
- Notifications sync (4.3+): Read your Android notifications
- Multimedia remote control: Use your phone as a remote control
- WiFi connection: no USB wire or Bluetooth needed
- RSA Encryption: your information is safe

Please note you will need to install KDE Connect on Android for this app to work:
https://play.google.com/store/apps/details?id=org.kde.kdeconnect_tp or
https://f-droid.org/en/packages/org.kde.kdeconnect_tp/

%{lang_package}
%prep
%setup -q -n %{name}-%{version}
%autopatch -p1

%build
%cmake_kf5 -d build
%make_jobs

%install
%kf5_makeinstall -C build

for translation_file in kdeconnect-{cli,core,kcm,kded,kio,plugins,urlhandler} plasma_applet_org.kde.kdeconnect; do
    %{find_lang} $translation_file %{name}.lang
done

# susefirewall config file
install -D -m 0644 %{S:100} \
    %{buildroot}%{_sysconfdir}/sysconfig/SuSEfirewall2.d/services/%{name}
install -D -m 0644 %{S:101} \
    %{buildroot}%{_libexecdir}/firewalld/services/%{name}.xml

%suse_update_desktop_file %{buildroot}%{_kf5_applicationsdir}/org.kde.kdeconnect.nonplasma.desktop Network RemoteAccess

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%license COPYING
%doc README*
%config(noreplace) %{_sysconfdir}/sysconfig/SuSEfirewall2.d/services/%{name}
%dir %{_datadir}/nautilus-python
%dir %{_libexecdir}/firewalld
%dir %{_libexecdir}/firewalld/services
%{_datadir}/nautilus-python/extensions/
%{_libexecdir}/firewalld/services/%{name}.xml
%{_kf5_libdir}/libkdeconnect*.so.*
%{_kf5_plugindir}/
%{_kf5_applicationsdir}/*.desktop
%dir %{_kf5_iconsdir}/hicolor/256x256
%dir %{_kf5_iconsdir}/hicolor/256x256/apps
%{_kf5_iconsdir}/hicolor/*/apps/kdeconnect.*
%{_kf5_libdir}/libexec/
%{_kf5_servicesdir}/
%{_kf5_notifydir}/
%{_kf5_servicetypesdir}/
%{_kf5_sharedir}/plasma/
%{_kf5_qmldir}/
%{_kf5_bindir}/kdeconnect-cli
%{_kf5_bindir}/kdeconnect-handler
%{_kf5_bindir}/kdeconnect-indicator
%{_kf5_sharedir}/dbus-1/services/org.kde.kdeconnect.service
%{_kf5_configdir}/autostart/kdeconnectd.desktop
%{_kf5_iconsdir}/hicolor/*/status/*
%{_kf5_htmldir}/en/kdeconnect/
%dir %{_kf5_appstreamdir}
%{_kf5_appstreamdir}/org.kde.kdeconnect.kcm.appdata.xml

%files lang -f %{name}.lang
%defattr(-,root,root)

%changelog
* Wed Dec 23 2020 Fabian Vogt <fabian@ritter-vogt.de>
- Add upstream patch to use fingerprinting for device
  verification (boo#1177672):
  * 0001-Show-the-KCM-with-the-run-commands-open-when-a-setup.patch
  * 0002-Add-a-verification-key-that-s-displayed-when-pairing.patch
* Fri Oct  2 2020 Luca Beltrame <lbeltrame@kde.org>
- Add upstream patches to fix security issues in kdeconnect
  (CVE-2020-26164, boo#1176268):
  * 0001-Do-not-leak-the-local-user-in-the-device-name.patch
  * 0002-Fix-use-after-free-in-LanLinkProvider-connectError.patch
  * 0003-Limit-identity-packets-to-8KiB.patch
  * 0004-Do-not-let-lanlink-connections-stay-open-for-long-wi.patch
  * 0005-Don-t-brute-force-reading-the-socket.patch
  * 0006-Limit-number-of-connected-sockets-from-unpaired-devi.patch
  * 0007-Do-not-remember-more-than-a-few-identity-packets-at-.patch
  * 0008-Limit-the-ports-we-try-to-connect-to-to-the-port-ran.patch
  * 0009-Do-not-replace-connections-for-a-given-deviceId-if-t.patch
* Fri Nov 16 2018 wbauer@tmo.at
- Update to the latest upstream version to fix file browsing with
  the newest Android app (boo#1116123)
* Wed Nov  7 2018 wbauer@tmo.at
- Update to 1.3.3
  * Instantiate QApplication object to fix crash on KDE Neon
    (kde#400178)
  * Fix build failure on musl based systems (kde#395161)
* Thu Oct 18 2018 wbauer@tmo.at
- Update to 1.3.2
  * Also allow modern algorithms, for compat with future apps
  * Remove characters from UUID that aren't legal in URLs
  * Add new notifications at the top of the list
  * Change the 'Dismiss all notifications' icon
  * Fix DBus signals in Mprisremote
* Fri Jun  1 2018 wbauer@tmo.at
- Update to 1.3.1
  * Fix a bug that would hang Nautilus when copying a file if
    paired devices were available
  * Fix remote filesystem reconnection issue
  * Add a missing dependency check in cmake
  * Add missing notification category to the plasmoid
- Mark license file with %%license instead of %%doc
* Mon Apr  9 2018 kamikazow@opensuse.org
- Update to 1.3.0
  * Fixed frequent crash when receiving notifications
  * Fixed MPRIS player entries never being deleted
  * Added a Gnome Files (Nautilus) extension to send files from the
    context menu
  * Added handling of "tel:" links with KDE Connect
  * Support sending album art in MPRIS plugin
  * Allow sharing more than one file from the CI (eg: --share *.mp3)
- Remove patches, now upstream:
  * 0001-Fix-null-dereference.patch
- Modified wording in Description to match that KDE Connect
  runs under any Linux desktop (see upstream README.md file)
* Tue Feb 20 2018 alarrosa@suse.com
- Add 0001-Fix-null-dereference.patch to fix a null dereference.
- Add signature file kdeconnect-kde-v1.2.1.tar.xz.sig
* Thu Jan 18 2018 wbauer@tmo.at
- Update to 1.2.1
  * Require the latest version of KF5
  * Was getting a double-delete, now it won't crash
  * Get rid of ProcessRunner
  * Add album art to mpris network packets
  * Add title, artist and album to MPRIS network packets
  * Fix information leak via /tmp (kde#383144)
  * Add support for new Android 2.3 (API 9+) cipher
  * Fix kdeconnect-cli device list
  * Fix "error activiting kdeconnectd" for kdeconnect-cli
  * Delay kdeconnectd autostart phase
  * Fix Notifications in Plasmoid
  * Make sure there's not a path within the filename
  * share plugin: fix path display
  * Use pactl instead of KMix in PauseMusic Plugin
- needs KDE Frameworks 5.42 now
* Sun Oct  1 2017 wbauer@tmo.at
- Update to 1.2.0
- Update build requirements, it needs Qt 5.7 and KF 5.38 now
- Remove patches, now upstream:
  * 0001-Treat-device-names-as-plaintext-not-rich-text.patch
* Wed Jul 12 2017 fabian@ritter-vogt.de
- Add patch to fix unauthenticated HTML injection (kde#382243):
  * 0001-Treat-device-names-as-plaintext-not-rich-text.patch
* Fri Dec 23 2016 ecsos@opensuse.org
- Update to 1.0.3
* Sat Nov 12 2016 hrvoje.senjan@gmail.com
- Update to 1.0.2
* Wed Sep 21 2016 wbauer@tmo.at
- Update to 1.0.1
  * fixes some issues found in 1.0
- Drop upstreamed fix-build-with-older-qt.patch
* Wed Sep  7 2016 wbauer@tmo.at
- Add fix-build-with-older-qt.patch from upstream to make it
  compile with Qt < 5.6, and lower the Qt requirement to 5.2 again
  (as demanded by CMakeLists.txt)
* Fri Aug 26 2016 herbert@graeber-clan.de
- Add firewalld service file
* Fri Aug 26 2016 fabian@ritter-vogt.de
- Build docs again
- Require at least Qt 5.6
* Fri Aug 26 2016 lbeltrame@kde.org
- New upstream version 1.0
  * Trigger custom commands from phone
  * Reply to SMS messages from the desktop
  * Receive desktop notifications on phone
  * TLS encryption
* Mon Feb  1 2016 hrvoje.senjan@gmail.com
- Update to 0.9g
  * No changelog provided
- Drop upstreamed 0001-This-syntax-also-works-on-older-OpenSSH-versions.patch
* Thu Jan 14 2016 alarrosa@suse.com
- Add 0001-This-syntax-also-works-on-older-OpenSSH-versions.patch from
  upstream to be compatible with older openssh versions (bnc#961554)
* Mon Nov 30 2015 toddrme2178@gmail.com
- Update to 0.9f
  * Adds translations
- Update to 0.9
  * KF5 version
* Fri Feb 20 2015 hrvoje.senjan@gmail.com
- Update to 0.8
  * No changelog provided
* Mon Jan 12 2015 tittiatcoke@gmail.com
- Add Requires:  sshfs  to make it work.
* Thu Oct 16 2014 hrvoje.senjan@gmail.com
- Update to 0.7.3:
  * No changelog provided
* Fri Sep 12 2014 hrvoje.senjan@gmail.com
- Update to 0.7.2:
  * No changelog provided
* Tue Jul  1 2014 fisiu@opensuse.org
- Update to 0.7.1:
  * Touchpad allows to scroll with 2 fingers, middle and right click.
  * Minor fixes.
* Sat Jun 28 2014 fisiu@opensuse.org
- Update to 0.7:
  * Use phone as cursor controller.
  * Allow android phone to receive files from PC.
  * Many bug fixes.
  * Translation available in 25 languages.
* Fri May 16 2014 hrvoje.senjan@gmail.com
- Update to 0.5.2.1
  * New upstream release, no changelog provided
* Sun Mar  9 2014 hrvoje.senjan@gmail.com
- Update to 0.5.1
  * New upstream release, no changelog provided
* Sat Feb 22 2014 fisiu@opensuse.org
- Update to 0.5.
- Build language package.
* Sat Dec 21 2013 fisiu@opensuse.org
- Add kdeconnect-kde.SuSEfirewall: config file for SuSEfirewall2.
* Fri Dec 20 2013 fisiu@opensuse.org
- Update to 0.4.2:
  * Plasmoid now displays the devices' battery.
  * Added standalone binary to run kdeconnect without kded.
  * Added a config dialog to pausemusic plugin.
  * Share plugin changed name.
  * The battery percentage for low battery level is now signaled by the device.
* Mon Nov 11 2013 hrvoje.senjan@gmail.com
- Update to version 0.4.1
  * New feature release, no changelog provided
* Tue Nov  5 2013 hrvoje.senjan@gmail.com
- Update to version 0.4
  * New feature release, no changelog provided
- Remove lang tar, translations removed also from tar
- BuildRequire libqjson-devel >= 0.8, as it doesn't build with older
  QJson
* Thu Oct  3 2013 hrvoje.senjan@gmail.com
- Update to version 0.3
  * New feature release
- Added lang tarball
* Mon Sep  9 2013 toddrme2178@gmail.com
- Initial version (0.1)
